/*
 * EC: Most of this code was shamelessly stolen from the [MULTINET.EXAMPLES]
 * directory.  Specifically, UDPECHOSERVER-ONE.C.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifndef __GNUC__
#include <starlet.h>
#endif
#include "multinet_root:[multinet.include.sys]types.h"
#include "multinet_root:[multinet.include.sys]socket.h"
#include "multinet_root:[multinet.include]errno.h"
#include "multinet_root:[multinet.include.vms]inetiodef.h"

    int recvfrom_with_timeout(int __fd, char *__buf, int __len,
    	    	    	      int __flags, struct sockaddr *__from,
    	    	    	      int *__fromlen, int __timeout);
/*    void bcopy(void *__source, void *__destination, int __length); */

/*
 *  This routine does a normal read using $QIO and also sets a timer.
 *  If no data arrives within the specified time, the read is aborted.
 */

int recvfrom_with_timeout(fd, buf, len, flags, from, fromlen, timeout)
int fd, len, timeout, flags, *fromlen;
struct sockaddr *from;
char *buf;
{
	unsigned short IOSB[4];
	int Status, TIME[2];
	struct {short int Length; char Sockaddr[sizeof(struct sockaddr)];}
		Local_Buffer;

	/*
	 *  Start the read on the socket.
	 */

/*	TIME[0] = -10000000 * timeout;  */  /* timeout in seconds */
        TIME[0] = -10000 * timeout;         /* timeout in milliseconds */
	TIME[1] = -1;
	Status = sys$qio(1,
			 fd,
			 IO$_RECEIVE,
			 IOSB,
			 0, 0,
			 buf,
			 len,
			 flags,
			 fromlen ? &Local_Buffer : 0,
			 fromlen ? sizeof(Local_Buffer) : 0,
			 0);

	if (!(Status&1)) {
		vmserrno = Status;
		if (vmserrno & 0x8000) {
		    vmserrno |= 0x4;
		    socket_errno = (Status & 0x7fff) >> 3;
		} else {
		    socket_errno = EIO;
		}
		return(-1);
	}

	/*
	 *  Start the timer
	 */

	Status = sys$setimr(2, TIME, 0, 0, 0);
	if (!(Status&1)) {
		vmserrno = Status;
		if (vmserrno & 0x8000) {
		    vmserrno |= 0x4;
		    socket_errno = (Status & 0x7fff) >> 3;
		} else {
		    socket_errno = EIO;
		}
		return(-1);
	}

	sys$wflor(1, (1<<1)|(1<<2));

	/*
	 *  Check if timer went off, or packet was received
	 */

	if (IOSB[0] == 0) {
	    /*
	     *	Timer went off. Cancel the I/O
	     */
	    sys$cancel(fd);
	    socket_errno = ETIMEDOUT;
	    vmserrno = 0x8004 | (ETIMEDOUT << 3);
	    return(-1);
	} else {
	    /*
	     *	I/O completed, cancel the timer.
	     */
	    sys$cantim(0,0);
	    /*
	     *	    Check for errors
	     */
	    if (!(IOSB[0] & 1)) {
		    vmserrno = IOSB[0];
		    if (vmserrno & 0x8000) {
			vmserrno |= 0x4;
			socket_errno = (IOSB[0] & 0x7fff) >> 3;
		    } else {
			socket_errno = EIO;
		    }
		    return(-1);
	    }
	}
	/*
	 *	Return the sockaddr to the user
	 */
	if (fromlen) {
		*fromlen = Local_Buffer.Length;
		bcopy(Local_Buffer.Sockaddr,
		      from,
		      sizeof(Local_Buffer.Sockaddr));
	}
	/*
	 *	And the character count
	 */
	return(IOSB[1]);
}

